#!/usr/bin/sh

. /etc/blackPanther-default-apps.conf
#*********************************************************************************************************
#*   __     __               __     ______                __   __                      _______ _______   *
#*  |  |--.|  |.---.-..----.|  |--.|   __ \.---.-..-----.|  |_|  |--..-----..----.    |       |     __|  *
#*  |  _  ||  ||  _  ||  __||    < |    __/|  _  ||     ||   _|     ||  -__||   _|    |   -   |__     |  *
#*  |_____||__||___._||____||__|__||___|   |___._||__|__||____|__|__||_____||__|      |_______|_______|  *
#* http://www.blackpantheros.eu | http://www.blackpanther.hu - kbarcza[]blackpanther.hu * Charles Barcza *
#*************************************************************************************(c)2002-2019********

if [ "$UID" != "0" ];then 
echo
echo "$RED ==> ROOT Required! Type 'rootmod' [enter] , add passwd and run again...$DEF"
echo 
exit
fi
echo -en "${YEL}Checking SQL service...: ${DEF}"
SQL_NET=$(cat /etc/my.cnf | grep '#skip-networking')
if [ ! -n "$SQL_NET" ];then
    echo "Cancelled!"
    echo " ==> SQL networking disabled in /etc/my.cnf!"
    echo " ==> Can't broadcasting MySQL/MariaDB on 3306 for connections"
    echo " ==> Set the MySQL/MariaDB for connection on 3306, example: comment skip-networking row and"
    echo " ==> test connection first in commandline, exmple: mysql -uDATABASEUSER -pDATABASEPASSWD -h localhost -P 3306"
    exit
 else
    echo -e "${GRN}Connaction available!$DEF";echo -e "${BLU}/You can doublecheck with: mysql -uDATABASEUSER -pDATABASEPASSWD -h localhost -P 3306/$DEF"
fi
echo "========================================="
echo -e "${GRN}Shinobi - Database Installation"
echo -e "${CYN}(y)es or (N)o$DEF"
read mysqlagreeData
if [ "$mysqlagreeData" = "y" ]; then
    cd /usr/share/shinobi/
    echo "What is your SQL Username?"
    read sqluser
    echo "What is your SQL Password?"
    read sqlpass
    mysql -u $sqluser -p$sqlpass -e "source /usr/share/shinobi/sql/user.sql" || true
    mysql -u $sqluser -p$sqlpass -e "source /usr/share/shinobi/sql/framework.sql" || true
    echo "Shinobi - Do you want to create a new user for viewing and managing cameras in Shinobi? You can do this later in the Superuser panel."
    echo "(y)es or (N)o"
    read mysqlDefaultData
    if [ "$mysqlDefaultData" = "y" ]; then
        escapeReplaceQuote='\\"'
        groupKey=$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | fold -w 7 | head -n 1)
        userID=$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | fold -w 6 | head -n 1)
        userEmail=$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | fold -w 6 | head -n 1)"@"$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | fold -w 6 | head -n 1)".com"
        userPasswordPlain=$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | fold -w 6 | head -n 1)
        userPasswordMD5=$(echo   -n   "$userPasswordPlain" | md5sum | awk '{print $1}')
        userDetails='{"days":"10"}'
        userDetails=$(echo "$userDetails" | sed -e 's/"/'$escapeReplaceQuote'/g')
        echo $userDetailsNew
        apiIP='0.0.0.0'
        apiKey=$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | fold -w 32 | head -n 1)
        apiDetails='{"auth_socket":"1","get_monitors":"1","control_monitors":"1","get_logs":"1","watch_stream":"1","watch_snapshot":"1","watch_videos":"1","delete_videos":"1"}'
        apiDetails=$(echo "$apiDetails" | sed -e 's/"/'$escapeReplaceQuote'/g')
        rm -f sql/default_user.sql || true
        #echo "USE ccio;INSERT INTO Users (\`ke\`,\`uid\`,\`auth\`,\`mail\`,\`pass\`,\`details\`) VALUES (\"$groupKey\",\"$userID\",\"$apiKey\",\"$userEmail\",\"$userPasswordMD5\",\"$userDetails\");INSERT INTO API (\`code\`,\`ke\`,\`uid\`,\`ip\`,\`details\`) VALUES (\"$apiKey\",\"$groupKey\",\"$userID\",\"$apiIP\",\"$apiDetails\"); > sql/default_user.sql"
        echo "USE ccio;INSERT INTO Users (\`ke\`,\`uid\`,\`auth\`,\`mail\`,\`pass\`,\`details\`) VALUES (\"$groupKey\",\"$userID\",\"$apiKey\",\"$userEmail\",\"$userPasswordMD5\",\"$userDetails\");INSERT INTO API (\`code\`,\`ke\`,\`uid\`,\`ip\`,\`details\`) VALUES (\"$apiKey\",\"$groupKey\",\"$userID\",\"$apiIP\",\"$apiDetails\");" > "sql/default_user.sql"
        echo "mysql -u $sqluser -p$sqlpass --database ccio -e source /usr/share/shinobi/sql/default_user.sql > /usr/share/shinobi/INSTALL/log.txt"
        mysql -u $sqluser -p$sqlpass --database ccio -e "source /usr/share/shinobi/sql/default_user.sql" > "/usr/share/shinobi/INSTALL/log.txt"
        echo "The following details will be shown again at the end of the installation."
        echo "====================================="
        echo "=======   Login Credentials   ======="
        echo "|| Username : $userEmail"
        echo "|| Password : $userPasswordPlain"
        echo "|| API Key : $apiKey"
        echo "====================================="
        echo "====================================="
        echo "** To change these settings login to either to the Superuser panel or login to the dashboard as the user that was just created and open the Settings window. **"
    fi
fi

pushd /usr/share/shinobi
echo
echo "======================================"
echo "Reconf Shinobi ?"
echo "(y)es or (N)o"
read reconfShinobi
if [ "$reconfShinobi" = "y" ]; then
    rm -f conf.json
    rm -f super.json
fi

if [ ! -e "./conf.json" ]; then
    cp conf.sample.json conf.json
    sed -i "s|\"user\":.*|\"user\": \"$sqluser\",|" conf.json
    sed -i "s|\"password\":.*|\"password\": \"$sqlpass\",|" conf.json


fi
if [ ! -e "./super.json" ]; then
    echo "Default Superuser : admin@shinobi.video"
    echo "Default Password : admin"
    cp super.sample.json super.json
fi

echo "Shinobi - Finished"
chmod -R 755 .
touch ./INSTALL/installed.txt
echo "=====================================" > ./INSTALL/installed.txt
echo "=======   Login Credentials   =======" >> ./INSTALL/installed.txt
echo "|| Username : $userEmail" >> ./INSTALL/installed.txt
echo "|| Password : $userPasswordPlain" >> ./INSTALL/installed.txt
echo "|| API Key : $apiKey" >> ./INSTALL/installed.txt
echo "=====================================" >> ./INSTALL/installed.txt
echo "=====================================" >> ./INSTALL/installed.txt
echo "Shinobi - Start Shinobi and set to start on boot?"
echo "(y)es or (N)o"
read startShinobi
if [ "$startShinobi" = "y" ]; then
    export PATH=./node_modules/.bin:$PATH
     pm2 start camera.js
     pm2 start cron.js
     pm2 startup
     pm2 save
     pm2 list
fi
echo "details written to ./INSTALL/installed.txt"
echo "====================================="
echo "=======   Login Credentials   ======="
echo "|| Username : $userEmail"
echo "|| Password : $userPasswordPlain"
echo "|| API Key : $apiKey"
echo "====================================="
echo "====================================="
popd >/dev/null
